/**
 * libSpiff - XSPF playlist handling library
 *
 * Copyright (C) 2006 Sebastian Pipping
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Sebastian Pipping, webmaster@hartwork.org
 */

#ifndef SPIFF_INDENT_PROPS_WRITER_H
#define SPIFF_INDENT_PROPS_WRITER_H 1



#include "SpiffDefines.h"
#include "SpiffAbstractPropsWriter.h"
#include <sstream>
using namespace std;

namespace Spiff {



class SpiffProps;



class SpiffIndentPropsWriter : public SpiffAbstractPropsWriter {

protected:
	basic_ostringstream<XML_Char> * output;
	SpiffProps * props;
	int trackCount;
	int version;

public:
	SpiffIndentPropsWriter(SpiffProps * props);
	virtual ~SpiffIndentPropsWriter();

protected:
	virtual void init(basic_ostringstream<XML_Char> & output, int version, int trackCount);
	virtual void writeHead();
	virtual void writeFoot();

protected:
	virtual void writeAnnotation();
	virtual void writeAttribution();
	virtual void writeCreator();
	virtual void writeDate();
	virtual void writeExtensions();
	virtual void writeIdentifier();
	virtual void writeImage();
	virtual void writeInfo();
	virtual void writeLicense();
	virtual void writeLink();
	virtual void writeLocation();
	virtual void writeMeta();
	virtual void writePlaylistClose();
	virtual void writePlaylistOpen();
	virtual void writeTitle();
	virtual void writeTrackListClose();
	virtual void writeTrackListOpen();

};



}

#endif // SPIFF_INDENT_PROPS_WRITER_H
