/**
 * libSpiff - XSPF playlist handling library
 *
 * Copyright (C) 2006 Sebastian Pipping
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Sebastian Pipping, webmaster@hartwork.org
 */

#ifndef SPIFF_INDENT_TRACK_WRITER_H
#define SPIFF_INDENT_TRACK_WRITER_H 1



#include "SpiffDefines.h"
#include "SpiffAbstractTrackWriter.h"
#include <sstream>
using namespace std;

namespace Spiff {



class SpiffTrack;



class SpiffIndentTrackWriter : public SpiffAbstractTrackWriter {

protected:
	basic_ostringstream<XML_Char> * output;
	SpiffTrack * track;
	int version;

public:
	SpiffIndentTrackWriter();
	virtual ~SpiffIndentTrackWriter();
	void setTrack(SpiffTrack * track);

protected:
	virtual void init(basic_ostringstream<XML_Char> & output, int version);
	virtual void write();

protected:
	virtual void writeAlbum();
	virtual void writeAnnotation();
	virtual void writeCreator();
	virtual void writeDuration();
	virtual void writeExtensions();
	virtual void writeIdentifiers();
	virtual void writeImage();
	virtual void writeInfo();
	virtual void writeLinks();
	virtual void writeLocations();
	virtual void writeMetas();
	virtual void writeTitle();
	virtual void writeTrackClose();
	virtual void writeTrackOpen();
	virtual void writeTrackNum();

};



}

#endif // SPIFF_INDENT_TRACK_WRITER_H
