/**
 * libSpiff - XSPF playlist handling library
 *
 * Copyright (C) 2006 Sebastian Pipping
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Sebastian Pipping, webmaster@hartwork.org
 */

#ifndef SPIFF_STACK_H
#define SPIFF_STACK_H 1



#include "SpiffDefines.h"
#include <vector>
using namespace std;

namespace Spiff {



enum SpiffTag {
	TAG_UNKNOWN,

	TAG_PLAYLIST,
	TAG_PLAYLIST_TITLE,
	TAG_PLAYLIST_CREATOR,
	TAG_PLAYLIST_ANNOTATION,
	TAG_PLAYLIST_INFO,
	TAG_PLAYLIST_LOCATION,
	TAG_PLAYLIST_IDENTIFIER,
	TAG_PLAYLIST_IMAGE,
	TAG_PLAYLIST_DATE,
	TAG_PLAYLIST_LICENSE,
	TAG_PLAYLIST_ATTRIBUTION,
	TAG_PLAYLIST_ATTRIBUTION_LOCATION,
	TAG_PLAYLIST_ATTRIBUTION_IDENTIFIER,
	TAG_PLAYLIST_LINK,
	TAG_PLAYLIST_META,
	TAG_PLAYLIST_EXTENSION,
	TAG_PLAYLIST_TRACKLIST,
	TAG_PLAYLIST_TRACKLIST_TRACK,
	TAG_PLAYLIST_TRACKLIST_TRACK_LOCATION,
	TAG_PLAYLIST_TRACKLIST_TRACK_IDENTIFIER,
	TAG_PLAYLIST_TRACKLIST_TRACK_TITLE,
	TAG_PLAYLIST_TRACKLIST_TRACK_CREATOR,
	TAG_PLAYLIST_TRACKLIST_TRACK_ANNOTATION,
	TAG_PLAYLIST_TRACKLIST_TRACK_INFO,
	TAG_PLAYLIST_TRACKLIST_TRACK_IMAGE,
	TAG_PLAYLIST_TRACKLIST_TRACK_ALBUM,
	TAG_PLAYLIST_TRACKLIST_TRACK_TRACKNUM,
	TAG_PLAYLIST_TRACKLIST_TRACK_DURATION,
	TAG_PLAYLIST_TRACKLIST_TRACK_LINK,
	TAG_PLAYLIST_TRACKLIST_TRACK_META,
	TAG_PLAYLIST_TRACKLIST_TRACK_EXTENSION,

	TAG_USER // New tags can start from this value
};



class SpiffStack {

private:
	vector<unsigned int> stack;

public:
	SpiffStack();
	~SpiffStack();

	void push(unsigned int tag);
	unsigned int top();
	void pop();
	int getSize();
	void clear();

};



}

#endif // SPIFF_STACK_H
